#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
int n, m;
ll a[1510][1510], tren[1510][1510], uk;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for(int i=0; i<n; i++) {
        for(int j=0; j<m; j++) {
            cin >> a[i][j];
        }
    }

    for(ll k=0; k<=29; k++) {
        for(int i=0; i<n; i++) {
            for(int j=0; j<m; j++) {
                tren[i][j]=a[i][j]&(1LL<<k);
            }
        }
        int par=0, nepar=0;
        for(int zb=0; zb<=n+m-2; zb++) {
            int br=0;
            for(int i=0, j=zb; i<=zb; i++, j--) {
                if(tren[i][j]) br++;
            }
            if(br&1) nepar++;
            else par++;
        }
        uk+=min(par, nepar)*(1LL<<k);
    }
    cout << uk;
    return 0;
}